/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_config.c 759 2008-05-24 17:01:20Z roi $
 */

/*
 *		ƥ¸⥸塼H8/300Hѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include <sil.h>
#include "pdic/h8/h8_sci.h"		/*  h8_sci_init  */
#include "target_syssvc.h"		/*  SYSTEM_PORTID  */

/*
 *  H8/300Hϥե̿᤬٤1ӥåȤĤեȤǤʤˤᡢ
 *  07ӥåȥեȤ̤ͽᡢROMΰ˳ǼƤ
 */
const uint8_t h8_bitshift[] = {
	0x01U,
	0x02U,
	0x04U,
	0x08U,
	0x10U,
	0x20U,
	0x40U,
	0x80U
};

const uint8_t h8_neg_bitshift[] = {
	0xfeU,		/*  ~0x01U  */
	0xfdU,		/*  ~0x02U  */
	0xfbU,		/*  ~0x04U  */
	0xf7U,		/*  ~0x08U  */
	0xefU,		/*  ~0x10U  */
	0xdfU,		/*  ~0x20U  */
	0xbfU,		/*  ~0x40U  */
	0x7fU 		/*  ~0x80U  */
};


/*
 *  IPMɽ鳰ɽѴ뤿Υơ֥
 */
const IIPM int_ipm_table[] = {
	IIPM_LEVEL0,
	IIPM_LEVEL1,
	IIPM_LEVEL2
};

/*
 *  CPUåե饰¸Τѿ
 */
		/* CPUåե饰ͤݻѿ */
bool_t lock_flag;
		/* ͥ٥ޥ¸ѿ */
IIPM saved_iipm;

/*
 *  ߥͥȥ
 */
uint8_t intnest;

/*
 *  ץå¸ν
 */
#ifndef H8IPRA_INI
#define H8IPRA_INI	0U
#endif  /*  H8IPRA_INI  */

#ifndef H8IPRB_INI
#define H8IPRB_INI	0U
#endif  /*  H8IPRB_INI  */

#ifndef H8IER_INI
#define H8IER_INI	0U
#endif  /*  H8IER_INI  */

void
prc_initialize(void)
{
	/*
	 *  CPUåե饰¸Τѿν
	 */
	lock_flag = true;
	saved_iipm = IIPM_ENAALL;
	intnest = 0U;

	/*
	 *  CCR UIӥåȤߥޥӥåȤȤƻѤ롣
	 *SYSCR.UE0
	 */
	bitclr((uint8_t *)H8SYSCR, H8SYSCR_UE_BIT);

	/*
	 *٤Ƥγߥץ饤ƥ٥룰ˤ
	 *
	 *˥䥹֤ߤѤ
	 *H8IPRA_INI, H8IPRB_INI, H8IER_INIơ
	 *Ƥݻ롣
	 */
	sil_wrb_mem((void *)H8IPRA, H8IPRA_INI);
	sil_wrb_mem((void *)H8IPRB, H8IPRB_INI);
	sil_wrb_mem((void *)H8IER, H8IER_INI);

	h8_sci_init(SYSTEM_PORTID);	/*  ׸Ƥ  */
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
}

/*
 *  ߥȥ
 */

/*
 *  ͥ٤
 *  ֹåϺѤǤ롣
 *  x_config_int()椫顢ֹ椬ʲξ˸ƤФ롣
 *  ʳֹ椬ͭʤΤǡipr_bit[intno]ͭʥӥåֹǤ롣
 *  IRQ
 *  ¢ڥե
 */
static void
h8_set_ilv(INTNO intno, PRI pri)
{
	uint8_t *p_ipr;
	uint8_t bit;

	/*  ͥ٤å  */
	assert((TMIN_INTPRI <= (pri)) && ((pri) <= TMAX_INTPRI));

	if (intno <= TMAX_INTNO_IPRA) {
		p_ipr = (uint8_t *)H8IPRA;
	} else {
		p_ipr = (uint8_t *)H8IPRB;
	}

	/*
	 *  ֹ椬ͭʤΤǡӥåֹͭ
	 */
	bit = ipr_bit[intno];
	if (pri == -1) {		/*  ߥץ饤ƥ٥룰  */
		bitclr(p_ipr, bit);
	} else {				/*  ߥץ饤ƥ٥룱  */
		bitset(p_ipr, bit);
	}
}


/*
 *  IRQֹбI/OݡֹѴޥ
 *
 *  I/OݡȤȤбطʲΤ褦ˤʤäƤȲꡣ
 *  ݡֹ
 *  IRQ0-3ݡ8
 *  ʳϥݡ9
 *  ӥåֹ
 *  IRQֹ椽Τޤ
 *  ۤʤϡåװ¸롣
 *  IRQ0 - P8_0
 *  IRQ1 - P8_1
 *  IRQ2 - P8_2
 *  IRQ3 - P8_3
 *  IRQ4 - P9_4
 *  IRQ5 - P9_5
 */
#ifndef IRQ_TO_IOPORT
#define IRQ_TO_IOPORT(irq)	(((irq) <= 3U) ? IO_PORT8 : IO_PORT9)
#endif	/*  IRQ_TO_IOPORT  */

#ifndef IRQ_TO_IOPORT_BIT
#define IRQ_TO_IOPORT_BIT(irq)	(irq)
#endif	/*  IRQ_TO_IOPORT_BIT  */

/*
 *  ׵饤°
 *
 *  H8/300Hξ硢װ礭3ʬव롣
 *  NMI
 *  IRQ
 *  ¢ڥե
 */

/*
 *  NMI׵饤°
 *  
 *  ֹ椬NMI˳ϡͥintpriϻѤʤ
 */
static void
x_config_int_nmi(ATR intatr)
{
	assert((intatr & (TA_POSEDGE | TA_NEGEDGE)) != 0U);
	
	if ((intatr & TA_NEGEDGE) != 0U) {	/*  Ωꥨå  */
		bitclr((int8_t *)H8SYSCR, H8SYSCR_NMIEG_BIT);
	} else {							/*  Ω夬ꥨå  */
		bitset((int8_t *)H8SYSCR, H8SYSCR_NMIEG_BIT);
	}
}

/*
 *  IRQ׵饤°
 *
 *  ջ
 *  IRQüҤϥץ륢å׵ǽ¢ƤʤΤǡ
 *  ӡ̤βϩǡ˥ץ륢åפɬפ롣
 */
static void
x_config_int_irq(INTNO intno, ATR intatr, PRI intpri)
{
	uint8_t irq, bit;
	IO_PORT io_port;

	irq = (uint8_t)(intno - TINTNO_IRQ0);		/*  IRQֹ  */

	/*
     *IRQϤ˻ѤԥϤˤ롣
     *ʳ߶ػߤˤȡŪϥݡȤʤ롣
     *IRQüҤϥݡȤˤʤʤ褦ˤ롣
	 */
	io_port = IRQ_TO_IOPORT(irq);		/*  бI/Oݡֹ  */
	bit = IRQ_TO_IOPORT_BIT(irq);		/*  бDDR쥸Υӥåֹ  */
    sil_anb_ddr(io_port, h8_neg_bitshift[bit]);

	(void)h8_disint_irq(irq);				/*  ̤γ׵ػ  */
	/*
	 *  ٥ȥꥬåȥꥬ
	*/
	if ((intatr & (TA_EDGE | TA_NEGEDGE)) != 0U) {		
										/*  åȥꥬξ  */
										/*    H8/300HΩꥨå  */
		bitset((int8_t *)H8ISCR, irq);
	} else {							/*  ٥ȥꥬξ  */
										/*    H8/300HLow٥  */
		bitclr((int8_t *)H8ISCR, irq);
	}
	h8_clr_irq(irq);					/*  ׵򥯥ꥢ  */
	h8_set_ilv(intno, intpri);			/*  ͥ٤  */
	
	/*
	 *  ׵Υޥɬפʾ
	 */
	if ((intatr & TA_ENAINT) != 0U) {
		(void)h8_enaint_irq(irq);
	}
}

/*
 *  ׵饤°
 *
 *VALID_INTNO_CFGINT(intno)trueȤʤintnoФƤΤ߸ƤФ롥
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *  
 *  H8/300Hξ硢װ礭3ʬव롣
 *  NMI
 *  IRQ
 *  ¢ڥե
 *  
 *  ֹ椬NMI˳ϡͥintpriϻѤʤ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	SIL_PRE_LOC;

	assert(VALID_INTNO_CFGINT(intno));
	assert(VALID_INTPRI_CHGIPM(intpri));

	SIL_LOC_INT();

	if (intno == TINTNO_NMI) {
		/*
		 *  NMIξ
		 */
		x_config_int_nmi(intatr);
	} else if (VALID_INTNO_IRQ(intno)) {
		/*
		 *  IRQξ
		 */
		x_config_int_irq(intno, intatr, intpri);
	} else {
		/*
		 *  ¢ڥեξ
		 */
		assert((intatr & TA_ENAINT) == 0U);

		/*
		 *  ͥ٤
		 */

		h8_set_ilv(intno, intpri);
	}
	SIL_UNL_INT();		/*  ߥå  */
}


/*****ʲȤΥ󥿡ե˴ޤޤʤʬ*********/

/*
 * ȯ˥ƥȤä
 * åݥ󥿤γǼ
 * ʳߥå
 */
extern STK_T *const	_kernel_istkpt;
#define ISTK_BOTTOM	((char *)_kernel_istkpt - 4)


#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ǥեȤγߥϥɥ
 * ϿƤʤߤȯȡ̾γ
 * ֥롼_default_int_handler_entryͳ
 * ƤӽФ롣
 * ֹȳƥ쥸ͤɽơߤ롣
 * 
 * å¤
 * 
 * ƥȤǳߤȯ
 * ߥå
 *  +0:er6
 *  +4:er5
 *  +8:er4
 * +12:_default_int_handler_entry
 * +16:åΥåݥ
 * 
 * å
 *  +0:er3
 *  +4:er2
 *  +8:er1
 * +12:er0
 * +16:crr
 * +17:pc
 * +20:˻ѤƤåΰ
 * 
 * 󥿥ƥȤǳߤȯ
 * ߥå
 *  +0:er6
 *  +4:er5
 *  +8:er4
 * +12:_default_int_handler_entry
 * +16:er3
 * +20:er2
 * +24:er1
 * +28:er0
 * +32:crr
 * +33:pc
 * +36:˻ѤƤåΰ
 */
void
default_int_handler(uint32_t *sp, uint8_t vector_no)
{
    uint32_t pc, ccr, tmp;
    uint32_t er0, er1, er2, er3, er4, er5, er6;

    er6 = *(sp++);
    er5 = *(sp++);
    er4 = *(sp++);
    ++sp;	/*  _default_int_handler_entryϤɤФ  */

	/*
	 * ȯΥƥȽ
	 * 
	 * ǤСintnestͤȽ̤ΤޡȤ
	 * ¿ųߤκݤintnestιάƤ뤿ᡢ
	 * åݥ󥿤ͤѤȽ̤Ƥ롣
	 */
    if (sp == (uint32_t *)ISTK_BOTTOM) {	/*  ƥ  */
		sp = (uint32_t *)(*sp);	/*  ƥȤΥåݥ  */
	}
    er3 = *(sp++);
    er2 = *(sp++);
    er1 = *(sp++);
    er0 = *(sp++);
    tmp = *(sp++);
    ccr = (tmp >> 24u) & 0xffU;	/*  1Х  */
    pc = tmp & 0x00ffffffU;	/*  3Х  */

	/*
	 * 쥸ͤɽ
	 * 
	 * 4Хȥǡɽ˥ݥ󥿷(%p)ѤƤΤϡ
	 * int2ХȤνϤǤѤ뤿ᡣ
	 */
    syslog(LOG_EMERG, "Unexpected interrupt.");
    syslog(LOG_EMERG, "vector no = %d(0x%02x)", vector_no, vector_no);
    syslog(LOG_EMERG, "PC  = 0x%08p SP  = 0x%08p CCR  = 0x%02x",
                       pc, sp, ccr);
    syslog(LOG_EMERG, "ER0 = 0x%08p ER1 = 0x%08p ER2 = 0x%08p ER3 = 0x%08p",
                       er0, er1, er2, er3);
    syslog(LOG_EMERG, "ER4 = 0x%08p ER5 = 0x%08p ER6 = 0x%08p",
                       er4, er5, er6);
    target_exit();
}

#endif	/*  OMIT_DEFAULT_INT_HANDLER  */


/*
 * I/OݡȤΥǡǥ쥯󡦥쥸DDRؤΥ
 *
 *H8DDRϽ񤭹ѤǤꡢΤޤޤǤϽ˾ΥӥåȤ
 *ѹ뤳ȤǤʤbset,bclr̿ǤԲġ
 *ΤᡢܼǤϡ˥ƥݥѰդơDDR
 *ͤݻˡΤäƤ롣
 *
 *ʤݡ7ѤDDR쥸ʤᡢάƤ롣
 */

#define	DUMMY	0

/*  Υƥݥΰ  */
static uint8_t ddr_tmp[] = {
	/* 1         2         3         4         5      */
	H8P1DDR0, H8P2DDR0, H8P3DDR0, H8P4DDR0, H8P5DDR0, 
	/* 6         8         9         A         B      */
	H8P6DDR0, H8P8DDR0, H8P9DDR0, H8PADDR0, H8PBDDR0
};

/*  ƥݡȤΥɥ쥹  */
static void *const ddr_adr[] = {
	(void *)H8P1DDR, (void *)H8P2DDR, (void *)H8P3DDR, 
	(void *)H8P4DDR, (void *)H8P5DDR, 
	(void *)H8P6DDR, (void *)H8P8DDR, (void *)H8P9DDR, 
	(void *)H8PADDR, (void *)H8PBDDR
};


/*
 *  DDRɤ߽Ф
 */
uint8_t
sil_reb_ddr(IO_PORT port)
{
	assert((IO_PORT1 <= port) && (port <= IO_PORTB));
	return ddr_tmp[port];
}

/*
 *  DDRν񤭹
 */
void
sil_wrb_ddr(IO_PORT port, uint8_t data)
{
	assert((IO_PORT1 <= port) && (port <= IO_PORTB));
	ddr_tmp[port] = data;
	sil_wrb_mem(ddr_adr[port], data);
}

/*
 *  DDRAND黻
 */
void
sil_anb_ddr(IO_PORT port, uint8_t data)
{
	uint8_t ddr = sil_reb_ddr(port);

	ddr &= data;
	sil_wrb_ddr(port, ddr);
}

/*
 *  DDROR黻
 */
void
sil_orb_ddr(IO_PORT port, uint8_t data)
{
	uint8_t ddr = sil_reb_ddr(port);

	ddr |= data;
	sil_wrb_ddr(port, ddr);
}

