/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_timer.c 473 2008-05-24 17:23:14Z roi $
 */

/*
 *  ޥɥ饤СH8/300Hѡ
 *
 *  IMIA0
 */
#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

/*
 *  ޼ñ̤ɽѴ
 */
#define CLOCK_PER_TICK	((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

/*
 *  
 */
Inline void
h8_timer_stop(void)
{
    bitclr((uint8_t *)SYSTEM_TIMER_TSTR, SYSTEM_TIMER_STR_BIT);
}

/*
 *  ޳׵Υꥢ
 *	TCR쥸IMFAӥåȤ1ɤ߽Фˣ񤭹
 */
Inline void
h8_timer_int_clear(void)
{
    /* GRAڥޥåγ׵ե饰򥯥ꥢ */
    bitclr((uint8_t *)SYSTEM_TIMER_IFR, SYSTEM_TIMER_IF_BIT);
}

/*
 *  ޤεư
 *     ޼ꤷޤư򳫻Ϥ롥
 */
void
target_timer_initialize(intptr_t exinf)
{
    h8_timer_stop();			/*  */

    /*  GRAڥޥåǥ󥿤򥯥ꥢʬ */
    sil_wrb_mem((void *)SYSTEM_TIMER_TCR, SYSTEM_TIMER_TCR_BIT);

    /*  GRAڥޥåˤ׵ */
    bitset((uint8_t *)SYSTEM_TIMER_IER, SYSTEM_TIMER_IE_BIT);
    

    /*  GRAڥޥåˤüҽ϶ػ */
    sil_wrb_mem((void *)SYSTEM_TIMER_TIOR, SYSTEM_TIMER_TIOR_BIT);

    /*  GRA쥸ʥɸ͡  	*/
    sil_wrh_mem((void *)SYSTEM_TIMER_GR, CLOCK_PER_TICK);

    sil_wrh_mem((void *)SYSTEM_TIMER_CNT, 0);	/* 󥿤򥯥ꥢ	*/

    h8_timer_int_clear();			/*  ׵򥯥ꥢ	*/

    /* ޥ */
    bitset((uint8_t *)SYSTEM_TIMER_TSTR, SYSTEM_TIMER_STR_BIT);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
    h8_timer_stop();			/*  */
    h8_timer_int_clear();		/* ׵򥯥ꥢ */
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
    h8_timer_int_clear();		/* ׵򥯥ꥢ */
    signal_time();              /* ƥåζ */
}

